import java.util.*;
import java.util.stream.*;
import static java.util.stream.Collectors.*;

public class String2Chars {
    static int caesarShift(int c) {
        if (!Character.isLetter(c))
            return c;
        return (c > 'z' - 13 ? c - 13 : c + 13);
    }
    
    public static void main(String[] args) {
        String decoded =
            "orjner 12vqrf 7 bs znepu".chars()
            // Arrays.stream("orjner 12vqrf 7 bs znepu".toCharArray()) // no go
               .filter(c -> Character.isLetter(c) || Character.isWhitespace(c))
               .map(Character::toLowerCase)
               .map(String2Chars::caesarShift)
               // .peek(c -> System.out.printf("%c",c))
               .mapToObj(c -> String.valueOf((char)c))
               // .forEach(c -> System.out.printf("%c", c));
               // .reduce("", (t,c) -> String.format("%s%s", t, c),
               //     (t,c) -> String.format("%s%s", t, c));
               .collect(Collectors.joining("", "Caesar was warned: ", 
				   ", but he didn't heed the warning"));
        System.out.println(decoded);
        System.out.println();
        // "The Ministry of Silly Walks"
        //     .chars()
        //     .map(Character::toLowerCase)
        //     .peek(c -> System.out.printf("%c", (char)c))
        //     .map(String2Chars::ceaserShift)
        //     .forEach(c -> System.out.printf(" -> %c%n", (char)c));
        // // System.out.println(total);
		Map<Character,Integer> freqs = "The Ministry of Silly Walks"
			.chars()
			.mapToObj(c -> Character.valueOf((char)c))
			.reduce(new HashMap<Character,Integer>(),
				(m,c) -> {m.put(c, m.getOrDefault(c, 0) + 1); return m;},
				(m1,m2) -> {m1.putAll(m2); return m1;});
		System.out.println(freqs);
    }
}